/*
    Bennu Convenience Lib Set.
    Copyright (C) 2010  Eugene Popov (popov_e_n@mail.ru)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

#ifndef USING_FENIX
import "mod_file";
import "mod_say";
import "mod_string";
#endif

type stringlist
  int ready = 0;
  int count;
  int allocated;
  string strings[ LIST_ALLOC_SEGMENT ];
  int readonly;
  //stringlist *next;
end;

function list_create_fn(stringlist *l, string filename)
local
  int cn, fd;
end
begin
  l.ready = 0;
  l.readonly = 1;
  fd = fopen( filename, O_READ );
  if( fd )
    cn = 0;
    while( ! feof(fd) && cn < LIST_ALLOC_SEGMENT )
      l.strings[ cn ] = fgets(fd); 
      cn++;
    end
    l.count = cn;
    l.ready = 1;
    fclose( fd );
  end
  return l.ready;
end;

/*--------------------------------------------------------------------------*/

function list_recontent( stringlist *l, string filename )
begin
  if( l.ready )
    list_free( l );
  end;
  list_create_fn( l, filename );
end;

/*--------------------------------------------------------------------------*/

function list_create(stringlist *l)
begin
  l.ready = 1;
  l.count = 0;
  return l.ready;
end;

/*--------------------------------------------------------------------------*/

function list_copy( stringlist *dst, stringlist *src )
begin
  if( dst.ready )
    list_free( dst );
  end;
  for( ; dst.count< src.count; dst.count++ )
    dst.strings[ dst.count ] = src.strings [ dst.count ];
  end
end;

/*--------------------------------------------------------------------------*/

function list_free( stringlist *l )
begin
  l.count = 0;
end;

/*--------------------------------------------------------------------------*/

function string list_item(stringlist *l, int item)
begin
  if( item<0 || item>=l.count )
    return "*out of bounds*";
  end;
  return l.strings[ item ];
end;

/*--------------------------------------------------------------------------*/

function list_grow(stringlist *l, string line)
begin
  if( l.readonly ) return ; end;
  if( l.ready && l.count < LIST_ALLOC_SEGMENT  )
    l.strings[ l.count ] = line;
    l.count ++;
  end;
end;
