
import "mod_string"
import "mod_file"
import "mod_mem"
import "mod_say"
       

#define TRANSL_MAX_LINES 1024
       
global
  string transl_lines_orig[ TRANSL_MAX_LINES ];
  string transl_lines_transl[ TRANSL_MAX_LINES ];
  int transl_lines_cnt = 0;
end
       
function int translation_load( string filename )
local
  int f, l;
  string s, t;
end
begin
  f = fopen (filename, "rt");
  if( !f )
    say("Cannot open translation: "+filename);
    return -1;
  end;
  
  transl_lines_cnt = 0;
  
  while( !feof(f) && transl_lines_cnt < TRANSL_MAX_LINES )
    s = fgets(f);
    t = fgets(f);
  
    l = len(s);
    if( l && s[0]=='"' && s[l-1]=='"')
      s = substr( s, 1, l-2 );
    
      l = len(t);
      if( l && t[0]=='"' && t[l-1]=='"')
	t = substr( t, 1, l-2 );
	transl_lines_orig[ transl_lines_cnt ]  = s;
	transl_lines_transl[ transl_lines_cnt ] = t;
	transl_lines_cnt++;
      end
      
    end
  end;
  
  fclose(f);
  return 0;
end

function string _(string message)
local
  int i;
end 
begin
  if( len(message) )
    for( i=0; i<transl_lines_cnt; i++ )
      if( transl_lines_orig[ i ] == message )
	return transl_lines_transl[ i ];
      end
    end
  end
  return message;
end
